/*
The Smack Player supports outputing the movie in 16-bit color
The game is 16-bit color except for the movies which play back in 8-bit
So we'll stomp the dd->SetDisplayMode( 640,480,8 ) call
and then tell the smack player to output in 16-bit color

Most of the new code from this patch is determining whether the user is has a 1-5-5-5 or 5-6-5  pixelformat
555 has a green mask of 0x3E0 -- 565 has a green mask of 0x7E0
AFAIK We need to pass the 0x80000000 flag to SmackToBuffer for 555 and 0xC0000000 for 565
In order to fit in this new code... I removed the the center movie along the x-axis code
All the movies have a width of 640 so it was useless anyways

We may actual take a quality hit cause we change from 256, 32-bit colors
To a probable 256, 16-bit colors...
But I doubt it will be a noticeable difference

// EBX is zero
// ESI is some pointer to movie data
// Surface is Locked, Lock() filled out the ddsd structure 
// the two existing relocations were used
0046C0DC      90             NOP
0046C0DD      8B15 CCF34900  MOV EDX,DWORD PTR DS:[49F3CC]   ; ddsd.ddpf.dwGBitMask
0046C0E3      C1EA 09        SHR EDX,9
0046C0E6      8B6E 49        MOV EBP,DWORD PTR DS:[ESI+49]   ; pSmk
0046C0E9      8B4D 08        MOV ECX,DWORD PTR SS:[EBP+8]    ; pSmk->VideoHeight
0046C0EC      B8 80F34900    MOV EAX,OFFSET 0049F380         ; &ddsd.pitch
0046C0F1      7A 01          JPE SHORT 0046C0F4
0046C0F3      42             INC EDX
0046C0F4      C1E2 1E        SHL EDX,1E
0046C0F7      52             PUSH EDX                      ;;; Smack Flags
0046C0F8      FF70 14        PUSH DWORD PTR DS:[EAX + 14]  ;;; lpvSurface
0046C0FA      51             PUSH ECX                      ;;; Height   
0046C0FB      FF30           PUSH DWORD PTR DS:[EAX]       ;;; pitch
0046C0FE      B8 E0010000    MOV EAX,1E0                   
0046C103      29C8           SUB EAX,ECX
0046C105      D1E8           SHR EAX,1
0046C107      50             PUSH EAX                      ;;; y
0046C108      53             PUSH EBX                      ;;; x = 0
0046C109      55             PUSH EBP                      ;;; pSmk
*/





#pragma comment(linker, "/NODEFAULTLIB") // specifically no C runtime lib
#pragma comment( lib, "kernel32" )
#pragma comment( lib, "user32" )
#pragma comment( lib, "comdlg32" )// for GetOpenFileName()
#pragma comment( lib, "advapi32" )// for registry stuff
#pragma comment(linker, "/ENTRY:\"myStart\"") // define entry point cause no C Lib
#pragma comment(linker, "/merge:.data=.text")
#pragma comment(linker, "/section:.text,RWE")// Read, Write, and Execute Access

#include <windows.h>

#define BUTTON_INSTALL   201
#define BUTTON_UNINSTALL 202
#define BUTTON_EXIT      203
#define BUTTON_BROWSE    204

HWND m_hMainWnd;
HWND m_hListBox;
HWND m_hEdit;
HWND m_hBrowse;
HWND m_hInstall;
HWND m_hUninstall;
HWND m_hExit;

#pragma intrinsic( strlen )
void __cdecl Log( char* fmt, ...)
{
	static char buf[ 1024 ];
	va_list args;
    va_start( args, fmt );
    wvsprintf( buf, fmt, args );
	va_end( args );

	// update horizontal scroll bar range for the listbox /obnoxious
	SIZE s;
	static long len = 0;
	HDC hDC = GetDC( m_hListBox );
	if( hDC )
	{
		if( GetTextExtentPoint32( hDC, buf, strlen( buf ), &s ) )
		{
			if( s.cx > len )
			{
				len = s.cx;
				SendMessage( m_hListBox, LB_SETHORIZONTALEXTENT, s.cx, 0 );
			}
		}
		ReleaseDC( m_hListBox, hDC );
	}

	// add item
	long item = SendMessage( m_hListBox, LB_ADDSTRING, 0, (LPARAM) buf );
	
	// start to roll if we get near the end 
	if( item >= 65000 ) SendMessage( m_hListBox, LB_DELETESTRING, 0, 0 ); 
}

void LogError( long last_error_code ){
	char* msg;
	if( FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		NULL, last_error_code,MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPSTR)&msg,0,NULL ))
	{
		Log( "%s", msg );
		LocalFree( msg );
	}
}

#pragma intrinsic( memcmp, memcpy )
void RemoveOldPatch( char* pFileBuf )
{
	const DWORD MsgHook_FileOffset = 0x000555AD;
	const BYTE MsgHook_Original_Data[] = { 0x0F, 0x85, 0x4D, 0x01, 0x00, 0x00 };
	const BYTE MsgHook_Patch_Data[]   = { 0x0F, 0x85, 0x73, 0x6C, 0x02, 0x00 };
	
	const DWORD MsgProc_FileOffset = 0x0007C226;
	const BYTE MsgProc_Original_Data[] = {
		0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,
		0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,
		0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,
		0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,
		0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,
		0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,
		0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,
		0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,
		0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,  0x00,
		0x00,  0x00 
	};
	const BYTE MsgProc_Patch_Data[] = {
		0x81, 0x7C, 0x24, 0x04, 0x11, 0x03, 0x00, 0x00,
		0x75, 0x3B, 0x54, 0xE8, 0x44, 0xFD, 0xFF, 0xFF,
		0x54, 0xE8, 0x38, 0xFD, 0xFF, 0xFF, 0x6A, 0x64,
		0xE8, 0x4F, 0xFD, 0xFF, 0xFF, 0x8B, 0xC4, 0x6A,
		0x01, 0x6A, 0x00, 0x6A, 0x00, 0x6A, 0x00, 0x50,
		0xE8, 0x2D, 0xFD, 0xFF, 0xFF, 0x84, 0xC0, 0x74,
		0xE5, 0x81, 0x7C, 0x24, 0x04, 0x12, 0x01, 0x00,
		0x00, 0x75, 0xCF, 0x81, 0x7C, 0x24, 0x08, 0x20,
		0xF1, 0x00, 0x00, 0x75, 0xC5, 0xE9, 0x90, 0x94,
		0xFD, 0xFF 
	};

	const DWORD VideoHook_FileOffset = 0x0005310F;
	const BYTE VideoHook_Original_Data[] = { 0x3D, 0xC2, 0x01, 0x76, 0x88 };
	const BYTE VideoHook_Patch_Data[]   = { 0xE8, 0x5C, 0x92, 0x02, 0x00 };

	const DWORD VideoProc_FileOffset = 0x0007C370;
	const BYTE VideoProc_Original_Data[] = {
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	};
	const BYTE VideoProc_Patch_Data[] = {
		0x50, 0x8B, 0xC4, 0x83, 0xC0, 0x04, 0x8B, 0x00,
		0x05, 0xF0, 0x03, 0x06, 0x00, 0x83, 0x38, 0x01,
		0x58, 0x74, 0x06, 0x3D, 0xC2, 0x01, 0x76, 0x88,
		0xC3, 0x58, 0xE9, 0xAA, 0x6D, 0xFD, 0xFF
	};

	if( !memcmp( pFileBuf + MsgHook_FileOffset,   MsgHook_Patch_Data,   sizeof( MsgHook_Patch_Data ) ) &&
		!memcmp( pFileBuf + MsgProc_FileOffset,   MsgProc_Patch_Data,   sizeof( MsgProc_Patch_Data ) ) &&
		!memcmp( pFileBuf + VideoHook_FileOffset, VideoHook_Patch_Data, sizeof( VideoHook_Patch_Data ) ) &&
		!memcmp( pFileBuf + VideoProc_FileOffset, VideoProc_Patch_Data, sizeof( VideoProc_Patch_Data ) ) )
	{
		Log("Old unoffical crash patch detected." );
		if( IDYES == MessageBoxA( m_hMainWnd, "Old unoffical crash patch detected.\nWould you like to Uninstall it?", "FL Patch", MB_YESNO ) )
		{
			memcpy( pFileBuf + MsgHook_FileOffset,   MsgHook_Original_Data,   sizeof( MsgHook_Original_Data   ) );
			memcpy( pFileBuf + MsgProc_FileOffset,   MsgProc_Original_Data,   sizeof( MsgProc_Original_Data   ) );
			memcpy( pFileBuf + VideoHook_FileOffset, VideoHook_Original_Data, sizeof( VideoHook_Original_Data ) );
			memcpy( pFileBuf + VideoProc_FileOffset, VideoProc_Original_Data, sizeof( VideoProc_Original_Data ) );
			Log("Old unoffical crash patch removed." );
		}
	}
}


#pragma intrinsic( memcmp, memcpy )
void ApplyPatch( BOOL bUninstall )
{
	char szExePath[MAX_PATH];
	HANDLE hFile;
	HANDLE hFileMap;
	char*  pFileBuf;
	DWORD dwStatus = 0;

	const DWORD SetDisplayMode_FileOffset = 0x0006B214;
	const BYTE SetDisplayMode_Patch_Data[] = { 16 };
	const BYTE SetDisplayMode_Original_Data[] = { 8 };

	const DWORD SmackToBufferArgs_FileOffset = 0x0006B4DC;
	const BYTE SmackToBufferArgs_Patch_Data[] = {
		0x90, 0x8B, 0x15, 0xCC, 0xF3, 0x49, 0x00, 0xC1, 0xEA, 0x09, 0x8B, 0x6E, 0x49, 0x8B, 0x4D, 0x08,
		0xB8, 0x80, 0xF3, 0x49, 0x00, 0x7A, 0x01, 0x42, 0xC1, 0xE2, 0x1E, 0x52, 0xFF, 0x70, 0x14, 0x51,
		0xFF, 0x30, 0xB8, 0xE0, 0x01, 0x00, 0x00, 0x29, 0xC8, 0xD1, 0xE8, 0x50, 0x53, 0x55
	};
	const BYTE SmackToBufferArgs_Original_Data[] = {
		0x53, 0x8B, 0x3D, 0x94, 0xF3, 0x49, 0x00, 0x8B, 0x46, 0x49, 0x57, 0x8B, 0x68, 0x08, 0x55, 0x8B,
		0x15, 0x80, 0xF3, 0x49, 0x00, 0x52, 0xBA, 0xE0, 0x01, 0x00, 0x00, 0x29, 0xEA, 0xD1, 0xEA, 0x8B,
		0x48, 0x04, 0x52, 0xBA, 0x80, 0x02, 0x00, 0x00, 0x29, 0xCA, 0xD1, 0xEA, 0x52, 0x50
	};

	if( ( !GetWindowText( m_hEdit, szExePath, sizeof( szExePath ) ) ) || ( -1 == GetFileAttributes( szExePath ) ) )
	{
		Log( "Failed - File Not Found: %s", szExePath ); 
		Log( "Click the \"Browse...\" button to browse for the game executable." ); 
		return;
	}

	hFile = CreateFile( szExePath, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if(hFile != INVALID_HANDLE_VALUE)
	{
		hFileMap = CreateFileMapping(hFile, NULL, PAGE_READWRITE, 0, 0, NULL );
		if(hFileMap != NULL)
		{ 
			pFileBuf = (char*)MapViewOfFile(hFileMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);
			if(pFileBuf != NULL)
			{
				if( bUninstall == FALSE )
				{	
					if( !memcmp( pFileBuf + SmackToBufferArgs_FileOffset, SmackToBufferArgs_Original_Data, sizeof( SmackToBufferArgs_Original_Data ) ) &&
						!memcmp( pFileBuf + SetDisplayMode_FileOffset, SetDisplayMode_Original_Data, sizeof( SetDisplayMode_Original_Data ) ))
					{
						RemoveOldPatch( pFileBuf );
						memcpy( pFileBuf + SmackToBufferArgs_FileOffset, SmackToBufferArgs_Patch_Data, sizeof( SmackToBufferArgs_Patch_Data ) );
						memcpy( pFileBuf + SetDisplayMode_FileOffset, SetDisplayMode_Patch_Data, sizeof( SetDisplayMode_Patch_Data ) );
						dwStatus = 3;
					}
					else
					{
						if( !memcmp( pFileBuf + SmackToBufferArgs_FileOffset, SmackToBufferArgs_Patch_Data, sizeof( SmackToBufferArgs_Patch_Data ) ) &&
							!memcmp( pFileBuf + SetDisplayMode_FileOffset, SetDisplayMode_Patch_Data, sizeof( SetDisplayMode_Patch_Data ) ))
						{		
							dwStatus = 2;
						}
						else dwStatus = 1;
					}
				}
				else
				{
					if( !memcmp( pFileBuf + SmackToBufferArgs_FileOffset, SmackToBufferArgs_Patch_Data, sizeof( SmackToBufferArgs_Patch_Data ) ) &&
						!memcmp( pFileBuf + SetDisplayMode_FileOffset, SetDisplayMode_Patch_Data, sizeof( SetDisplayMode_Patch_Data ) ))
					{	
						memcpy( pFileBuf + SmackToBufferArgs_FileOffset, SmackToBufferArgs_Original_Data, sizeof( SmackToBufferArgs_Original_Data ) );
						memcpy( pFileBuf + SetDisplayMode_FileOffset, SetDisplayMode_Original_Data, sizeof( SetDisplayMode_Original_Data ) );
						dwStatus = 5;
					}
					else
					{
						if( !memcmp( pFileBuf + SmackToBufferArgs_FileOffset, SmackToBufferArgs_Original_Data, sizeof( SmackToBufferArgs_Original_Data ) ) &&
							!memcmp( pFileBuf + SetDisplayMode_FileOffset, SetDisplayMode_Original_Data, sizeof( SetDisplayMode_Original_Data ) ))
						{
							dwStatus = 4;
						}
						else dwStatus = 6;
					}
				}
				UnmapViewOfFile(pFileBuf);
			}
			CloseHandle(hFileMap);    
		}
		CloseHandle(hFile); 
	}

	switch( dwStatus )
	{
	case 0:
		{
			DWORD dwLastError = GetLastError();
			Log( "Failed - Couldn't Open File: %s", szExePath ); 
			LogError( dwLastError );
			break;
		}
	case 1:
		Log( "Failed - Incompatible File: Unexpected data at patch locations." ); 
		Log( "Make sure you have the offical v1.01 patch installed." );
		break;
	case 2:
		Log( "Aborted - Patch Already Installed." );
		break;
	case 3:
		Log( "Success - Patch Installed: Have Fun!" );
		break;
	case 4:
		Log( "Aborted - Patch Not Installed." );
		break;
	case 5:
		Log( "Success - Patch Uninstalled." );
		break;
	case 6:
		Log( "Failed - Incompatible File: Unexpected data at patch locations." );
		break;
	}
	Log("");
}


long __stdcall WindowProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_DESTROY:
		PostQuitMessage( 0 );
		return 0;
	case WM_SIZE:
		{
			if( ( wParam == SIZE_MAXHIDE ) || ( wParam == SIZE_MINIMIZED ) ) return 0;

			DWORD dwHeight = HIWORD( lParam );
			DWORD dwWidth = LOWORD( lParam );

			if( dwHeight < 200 ) dwHeight = 200; // lies

			MoveWindow( m_hListBox,
				10,
				10,
				dwWidth - 20,
				dwHeight - 120,
				TRUE
			);
			MoveWindow( m_hEdit,
				10,
				dwHeight - 100,
				dwWidth - 110,
				20,
				TRUE 
			);
			MoveWindow( m_hBrowse,
				dwWidth - 90,
				dwHeight - 102,
				80,
				24,
				TRUE
			);
			MoveWindow( m_hInstall,
				( dwWidth - 260 ) >> 1,
				dwHeight - 70,
				80,
				24,
				TRUE
			);
			MoveWindow( m_hUninstall, 
				( ( dwWidth - 260 ) >> 1 ) + 90,
				dwHeight - 70,
				80,
				24,
				TRUE 
			);
			MoveWindow( m_hExit,
				( ( dwWidth - 260 ) >> 1 ) + 180,
				dwHeight - 70,
				80,
				24,
				TRUE
			);
		}
		return 0;
	case WM_GETMINMAXINFO:
		{
			DWORD dwStyle = WS_OVERLAPPEDWINDOW | WS_VISIBLE; 
			RECT rc = { 0, 0, 280, 165 }; // desired client size
			AdjustWindowRect(&rc, dwStyle, FALSE);
			((MINMAXINFO*)lParam)->ptMinTrackSize.x = rc.right - rc.left;
			((MINMAXINFO*)lParam)->ptMinTrackSize.y = rc.bottom - rc.top;
		}
		return 0;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case BUTTON_INSTALL:
			ApplyPatch( FALSE );
			return 0;
		case BUTTON_UNINSTALL:
			ApplyPatch( TRUE );
			return 0;
		case BUTTON_EXIT:
			PostQuitMessage( 0 );
			return 0;
		case BUTTON_BROWSE:
			{
				char szExePath[MAX_PATH];
				OPENFILENAME ofn;
				RtlSecureZeroMemory(&ofn, sizeof( ofn ) ); 
				*szExePath = '\0';
				ofn.lStructSize = sizeof( ofn );
				ofn.lpstrTitle = "Please select the file: Epic40k.exe";
				ofn.lpstrFilter = "*.exe\0*.exe\0All Files\0*\0";
				ofn.lpstrFile = szExePath;
				ofn.nMaxFile = sizeof( szExePath );
				ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST;
				if( GetOpenFileName( &ofn ) ) SetWindowText( m_hEdit, szExePath );
				return 0;
			}
		}
		break;
	case WM_PARENTNOTIFY:
		{	// set the font of child windows
			if( ( LOWORD( wParam ) ) == WM_CREATE )
			{
				static HFONT hFont = NULL;
				if( hFont == NULL ) hFont = CreateFont(15,0,0,0,0,0,0,0,0,0,0,0,0,0);
				SendMessage((HWND)lParam,WM_SETFONT,(WPARAM)hFont,MAKELPARAM(FALSE, 0));
				return 0;
			}
			break;
		}
	}
    return DefWindowProc( hWnd, uMsg, wParam, lParam );
}




void GetExePath( HWND hWnd )
{
	char szExePath[MAX_PATH];
	HKEY key = 0;

	// check current directory
	if( SearchPath( NULL, "Epic40k.exe", NULL, sizeof( szExePath ), szExePath, NULL))
	{
		SetWindowText( hWnd, szExePath );
		return;
	}
	
	// check registry for install
	if( ERROR_SUCCESS == RegOpenKeyEx(HKEY_LOCAL_MACHINE, 
		"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\Epic40k.exe", 0,  KEY_READ, &key))
	{
		long path_size = sizeof( szExePath );
		long value_type = REG_SZ;
		long result = RegQueryValueEx(key, 0, NULL, (LPDWORD)&value_type, (LPBYTE)szExePath, (LPDWORD)&path_size );
		RegCloseKey(key);
		if( ERROR_SUCCESS == result )
		{
			if( -1 != GetFileAttributes( szExePath ) ) // if file exists
			{
				SetWindowText( hWnd, szExePath );
				return;
			}
		}
	}
	SetWindowText( hWnd, "Epic40k.exe NOT found" );
}

void __cdecl myStart()
{
	// do window
	WNDCLASS wc = { CS_HREDRAW | CS_VREDRAW, WindowProc, 0, 0, GetModuleHandle( 0 ),
		LoadIcon( NULL, IDI_APPLICATION ), LoadCursor( NULL, IDC_ARROW ), GetSysColorBrush( COLOR_BTNFACE ),
		0, "FL Patch"  
	};    
	RegisterClass( &wc );

	DWORD dwStyle = WS_OVERLAPPEDWINDOW | WS_VISIBLE; 
	RECT rc = { 0, 0, 500, 400 }; // desired client size
	AdjustWindowRect(&rc, dwStyle, FALSE);

	m_hMainWnd = CreateWindow( wc.lpszClassName, wc.lpszClassName, dwStyle,
		CW_USEDEFAULT, CW_USEDEFAULT, rc.right - rc.left, rc.bottom - rc.top,
		0, 0, wc.hInstance, 0 );

	m_hListBox = CreateWindow( "LISTBOX", 0,
		LBS_NOINTEGRALHEIGHT | LBS_HASSTRINGS | LBS_NOSEL | WS_VISIBLE | WS_CHILD | WS_BORDER | WS_VSCROLL | WS_HSCROLL, 
		10, 10, 480, 280, m_hMainWnd, 0, wc.hInstance, 0 );

	m_hEdit = CreateWindow( "EDIT", NULL,
		ES_AUTOHSCROLL | WS_CHILD | WS_VISIBLE | WS_BORDER, 10, 300, 390, 20,
		m_hMainWnd, 0, wc.hInstance, NULL );

	m_hBrowse = CreateWindow( "BUTTON","Browse...", 
		WS_CHILD | WS_VISIBLE, 410, 298, 80, 24,
		m_hMainWnd, (HMENU)BUTTON_BROWSE, wc.hInstance, NULL );

	m_hInstall = CreateWindow("BUTTON","Install", 
		WS_CHILD | WS_VISIBLE, 120, 330, 80, 24,
		m_hMainWnd, (HMENU)BUTTON_INSTALL, wc.hInstance, NULL);

	m_hUninstall = CreateWindow("BUTTON","Uninstall", 
		WS_CHILD | WS_VISIBLE, 210, 330, 80, 24,
		m_hMainWnd, (HMENU)BUTTON_UNINSTALL, wc.hInstance, NULL);

	m_hExit = CreateWindow("BUTTON","Exit", 
		WS_CHILD | WS_VISIBLE, 300, 330, 80, 24,
		m_hMainWnd, (HMENU)BUTTON_EXIT, wc.hInstance, NULL);

	GetExePath( m_hEdit );

	Log( "Unoffical High-Color Patch for Epic40k: Final Liberation v1.01" );
	Log( "by aqrit ( www.bitpatch.com )" );
	Log( "" );
	Log( "Forces movie playback in 16-bit color." );
	Log( "" );
	Log( "The display mode no longer changes when playing movies." );
	Log( "Which hopefully stops the crashing on WinXP." );
	Log( "" );
	Log( "The system color palette is bypassed." );
	Log( "Which avoids the color corruption problems on Win6+." );
	Log( "" );
	Log( "====================================================" );
	Log( "" );
	MSG	msg;
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg ); // for edit box
		DispatchMessage( &msg );
	}

	ExitProcess(0);
}